from __future__ import division, print_function, unicode_literals

import sys
import os

import tkinter as Tk
from tkinter import TkVersion
from tkinter.simpledialog import Dialog
from tkinter import filedialog as FileDialog
from tkinter.scrolledtext import ScrolledText
import tkinter.font as Font
import tkinter.ttk as ttk
# import tkinter.tix as tix

from TkDndWrapper       import TkDND
from TkSupplements      import tk_set_icon_portable     # for backward compatibility

if sys.version_info > (3,6):
    from idlelib.tooltip    import ToolTip
else:
    from idlelib.ToolTip    import ToolTip
# from TkSupplements      import tk_set_icon_portable

def is_empty_var( var ):
    return var is None or var == '' or var[0] == '<' or var == 'None' 

def checkFolder( parent, folder_var, folder_entry ):
    # TODO: include these checks in a custom widget class
    def set_error( entry ):
        entry.config( fg='red' )
        entry.focus_force()

    ok_ = False
    folder = folder_var.get()
    if is_empty_var( folder ):
        set_error( folder_entry )
        MessageBox.showerror( "Input Folder Error", "The Input Folder is required.", parent=parent )
    elif not os.path.exists( folder ):
        set_error( folder_entry )
        MessageBox.showerror( "Input Folder Error", "'%s' does not exist." % in_folder, parent=parent )
    elif not os.path.isdir( folder ):
        set_error( folder_entry )
        MessageBox.showerror( "Input Folder Error", "'%s' is not a folder." % in_folder, parent=parent )
    else:
        folder_entry.config( fg='black' )
        ok_ = True

    return ok_
