# coding: utf-8
"""

    ファイル名：   TkUtils.py

    処理内容：

        

"""
from __future__ import division, print_function, unicode_literals

import os
import sys
import re

def split_geometry( geometry ):
    n = geometry.split('+')
    s = n[0].split('x')
    w = int( s[0] )
    h = int( s[1] )
    x = int( n[1] )
    y = int( n[2] )
    return [ w, h, x, y ]

def join_geometry( w, h, x, y ):
    return '%dx%d+%d+%d' % ( w, h, x, y )

def geometry_fix( top, x, y ):
    W, H, X, Y = split_geometry( top.geometry() )
    top.geometry( join_geometry( W, H, x, y ) )
    top.update()

"""
    URL: http://effbot.org/tkinterbook/wm.htm
"""
def parsegeometry(geometry):
    m = re.match("(\d+)x(\d+)([-+]\d+)([-+]\d+)", geometry)
    if not m:
        raise ValueError("failed to parse geometry string")
    return map(int, m.groups())

def convert_to_tkgeometry( monitor ):
    return re.sub( r'monitor\((.+)\)', '\g<1>', str( monitor ) )

monitors = None
max_monitor = None

def get_max_monitor():
    global monitors, max_monitor

    if max_monitor is not None: return max_monitor

    if monitors is None:
        try:
            from screeninfo import get_monitors
            monitors = get_monitors()
        except:
            print( 'screeninfo is not installed.' )
            monitors = []

    for m in monitors:
        # print( str( m ) )
        if max_monitor is None or m.width + m.height > max_monitor.width + max_monitor.height:
            max_monitor = m

    return max_monitor

do_not_adjust_geometry = os.environ.get( 'DO_NO_ADJUST_GEOMETRY' )
"""
    TODO:
    some tests seem to go wrong with adjusted geometry.
    it may have been improved by self.udate() before applying adjusted geometry.
"""

def adjusted_geometry( geometry, monitor=None ):
    global max_monitor

    if do_not_adjust_geometry:
        return geometry

    if monitor is None:
        monitor = get_max_monitor()

    try:
        w0, h0, x0, y0 = split_geometry( geometry )
        w1, h1, x1, y1 = monitor.width, monitor.height, monitor.x,  monitor.y
        if w1 > w0: w1 = w0
        if h1 > h0: h1 = h0
        return join_geometry( w1, h1, x1 + x0, y1 + y0 )
    except:
        return geometry
